/*
 * Copyright (C) 2013, 2014 Giorgio Vazzana
 *
 * This file is part of Seren.
 *
 * Seren is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Seren is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef NC_H
#define NC_H

#include <time.h>
#include <ncurses.h>

/* ncurses context */
#define LBS 1024
struct NContext {
	int                  initialized;
	int                  rows, cols;
	WINDOW              *win;
	/* keyboard input */
	char                 linebuf[2*LBS];
	unsigned int         linepos;
	unsigned char        wlinebuf[LBS][2];
	unsigned int         wlinepos;
};

extern struct NContext   nctx;

int nc_init(const char *version, const char *nick, int theme);
void nc_close(void);
void print_bars(const char *version);
void print_prompt(const char *nick);
void clear_input_line(int delete_buffer);

void nc_print_cb(time_t ts, unsigned int type, const char *module, const char *msg);

#endif
